<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/23/2004 *
 * ================                             Last change: 11/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_refid.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Setup default referal ID                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Standart Referal-ID einstellen                   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

if (IS_FORM_SENT()) {
	// Save data
	ADMIN_SAVE_SETTINGS_POST();
} else {
	// Prepare contants for the template
	define('__MEMBER_SELECTION', ADD_MEMBER_SELECTION_BOX(getConfig('def_refid'), false, true, true, "def_refid"));

	switch (getConfig('refid_target')) {
		case 'index':
			define('__DEF_RT_INDEX'   , ' selected="selected"');
			define('__DEF_RT_REGISTER', '');
			break;

		case 'register':
			define('__DEF_RT_INDEX'   , '');
			define('__DEF_RT_REGISTER', ' selected="selected"');
			break;

		default: // Invalid config!
			DEBUG_LOG(__FILE__, __LINE__, sprintf("Invalid refid_target %s detected.", getConfig('refid_target')));
			break;
	} // END - switch

	switch (getConfig('select_user_zero_refid')) {
		case 'Y':
			define('__RAND_REFID_Y', ' selected="selected"');
			define('__RAND_REFID_N', '');
			break;

		case 'N':
			define('__RAND_REFID_Y', '');
			define('__RAND_REFID_N', ' selected="selected"');
			break;

		default: // Invalid config!
			DEBUG_LOG(__FILE__, __LINE__, sprintf("Invalid select_user_zero_refid %s detected.", getConfig('select_user_zero_refid')));
			define('__RAND_REFID_Y', '');
			define('__RAND_REFID_N', '');
			break;
	} // END - switch

	// Prepare content
	$content = array(
		'user_min_confirmed' => getConfig('user_min_confirmed')
	);

	// Load template
	LOAD_TEMPLATE("admin_config_refid", false, $content);
}

// [EOF]
?>
